const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

customer_code: {
        type: DataTypes.TEXT,
      
      

      },

preferred_contact_channel: {
        type: DataTypes.TEXT,
      
      

      },

accepts_marketing: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

company_name: {
        type: DataTypes.TEXT,
      
      

      },

tax_identifier: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






    db.customers.hasMany(db.devices, {
      as: 'devices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.repair_orders, {
      as: 'repair_orders_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });






    db.customers.hasMany(db.invoices, {
      as: 'invoices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });




    db.customers.hasMany(db.ai_chat_sessions, {
      as: 'ai_chat_sessions_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });





//end loop



    db.customers.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


